package com.casic.dcms.ui.fragment.verify;

import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.casic.dcms.adapter.CaseVerifyResultAdapter;
import com.casic.dcms.base.AndroidxBaseFragment;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.bean.CaseVerifyBean;
import com.casic.dcms.databinding.FragmentVerifyCaseBinding;
import com.casic.dcms.mvp.presenter.impl.CaseVerifiedPresenterImpl;
import com.casic.dcms.mvp.view.ICaseVerifyView;
import com.casic.dcms.ui.CaseVerifiedDetailActivity;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.ToastHelper;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

public class CaseVerifiedFragment extends AndroidxBaseFragment<FragmentVerifyCaseBinding> implements ICaseVerifyView {

    private static final String TAG = "CaseHandledFragment";
    private Context context;
    private CaseVerifiedPresenterImpl caseVerifiedPresenter;
    private int pageIndex = 1;
    private CaseVerifyResultAdapter adapter;
    /**
     * 临时存储网络请求到的数据
     */
    private List<CaseVerifyBean.DataBean.RowsBean> dataBeans = new ArrayList<>();
    private boolean isRefresh, isLoadMore = false;
    private static WeakReferenceHandler weakReferenceHandler;

    @Override
    protected void setupTopBarLayout() {
        context = getContext();
    }

    @Override
    protected void initData() {
        caseVerifiedPresenter = new CaseVerifiedPresenterImpl(this);
        caseVerifiedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, pageIndex);

        weakReferenceHandler = new WeakReferenceHandler(this);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                //刷新之后页码重置
                pageIndex = 1;
                caseVerifiedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, pageIndex);
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                caseVerifiedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, pageIndex);
            }
        });
    }

    /**
     * 供{@link com.casic.dcms.ui.CaseVerifyDetailActivity#obtainCaseHandleResult(ActionResultBean)}调用
     */
    public static void sendEmptyMessage(int what) {
        if (weakReferenceHandler == null) {
            return;
        }
        weakReferenceHandler.sendEmptyMessage(what);
    }

    private static class WeakReferenceHandler extends Handler {
        private final WeakReference<CaseVerifiedFragment> reference;

        private WeakReferenceHandler(CaseVerifiedFragment fragment) {
            reference = new WeakReference<>(fragment);
        }

        @Override
        public void handleMessage(Message msg) {
            CaseVerifiedFragment verifiedFragment = reference.get();
            if (msg.what == Constant.CASE_VERIFY_OK) {
                Log.d(TAG, "核实成功，更新列表");
                verifiedFragment.isRefresh = true;
                //刷新之后页码重置
                verifiedFragment.pageIndex = 1;
                verifiedFragment.caseVerifiedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, verifiedFragment.pageIndex);
            } else if (msg.what == 202104254) {
                if (verifiedFragment.isRefresh || verifiedFragment.isLoadMore) {
                    verifiedFragment.adapter.notifyDataSetChanged();
                } else {
                    //首次加载数据
                    if (verifiedFragment.dataBeans.size() == 0) {
                        verifiedFragment.viewBinding.emptyView.show("您还没有已办案卷", null);
                    } else {
                        verifiedFragment.viewBinding.emptyView.hide();
                        verifiedFragment.adapter = new CaseVerifyResultAdapter(verifiedFragment.context, verifiedFragment.dataBeans);
                        verifiedFragment.viewBinding.caseRecyclerView.setLayoutManager(new LinearLayoutManager(verifiedFragment.context));
                        verifiedFragment.viewBinding.caseRecyclerView.addItemDecoration(new DividerItemDecoration(verifiedFragment.context, DividerItemDecoration.VERTICAL));
                        verifiedFragment.viewBinding.caseRecyclerView.setAdapter(verifiedFragment.adapter);
                        verifiedFragment.adapter.setOnItemClickListener(new CaseVerifyResultAdapter.OnItemClickListener() {
                            @Override
                            public void onClick(int position) {
                                Intent intent = new Intent(verifiedFragment.context, CaseVerifiedDetailActivity.class);
                                intent.putExtra("id", verifiedFragment.dataBeans.get(position).getId());
                                verifiedFragment.startActivity(intent);
                            }
                        });
                    }
                }
            }
        }
    }

    @Override
    public void obtainVerifyListResult(CaseVerifyBean resultBean) {
//        Log.d(TAG, "obtainVerifiedListResult: "+new Gson().toJson(resultBean));
        if (resultBean.isSuccess()) {
            List<CaseVerifyBean.DataBean.RowsBean> dataRows = resultBean.getData().getRows();
            if (isRefresh) {
                dataBeans.clear();//下拉刷新必须先清空之前的List，不然会出现数据重复的问题
                dataBeans = dataRows;
                viewBinding.refreshLayout.finishRefresh();
                isRefresh = false;
            } else if (isLoadMore) {
                if (dataRows.size() == 0) {
                    ToastHelper.showToast("到底了，别拉了", ToastHelper.INFO);
                }
                dataBeans.addAll(dataRows);
                viewBinding.refreshLayout.finishLoadMore();
                isLoadMore = false;
            } else {
                dataBeans = dataRows;
            }
            weakReferenceHandler.sendEmptyMessage(202104254);
        }
    }

    @Override
    public void onDestroyView() {
        if (caseVerifiedPresenter != null) {
            caseVerifiedPresenter.disposeRetrofitRequest();
        }
        super.onDestroyView();
    }
}
